--Legal Notice: (C)2007 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity CORE_nios is 
        port (
              -- inputs:
                 signal CLK50 : IN STD_LOGIC;
                 signal KEY_core : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal TD_DATA_core : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal TD_HS_core : IN STD_LOGIC;
                 signal TD_VS_core : IN STD_LOGIC;
                 signal address : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal chipselect : IN STD_LOGIC;
                 signal clk27 : IN STD_LOGIC;
                 signal read : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal write : IN STD_LOGIC;
                 signal writedata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

              -- outputs:
                 signal Linecount_core : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal TD_RESET_core : OUT STD_LOGIC;
                 signal VGA_BLANK_core : OUT STD_LOGIC;
                 signal VGA_B_core : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal VGA_CLK_core : OUT STD_LOGIC;
                 signal VGA_G_core : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal VGA_HS_core : OUT STD_LOGIC;
                 signal VGA_R_core : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal VGA_SYNC_core : OUT STD_LOGIC;
                 signal VGA_VS_core : OUT STD_LOGIC;
                 signal bluecount : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal readdata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal x_blue : OUT STD_LOGIC_VECTOR (9 DOWNTO 0)
              );
end entity CORE_nios;


architecture europa of CORE_nios is
component CORE is 
           port (
                 -- inputs:
                    signal CLK50 : IN STD_LOGIC;
                    signal KEY_core : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal TD_DATA_core : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal TD_HS_core : IN STD_LOGIC;
                    signal TD_VS_core : IN STD_LOGIC;
                    signal address : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk27 : IN STD_LOGIC;
                    signal read : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal Linecount_core : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal TD_RESET_core : OUT STD_LOGIC;
                    signal VGA_BLANK_core : OUT STD_LOGIC;
                    signal VGA_B_core : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal VGA_CLK_core : OUT STD_LOGIC;
                    signal VGA_G_core : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal VGA_HS_core : OUT STD_LOGIC;
                    signal VGA_R_core : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal VGA_SYNC_core : OUT STD_LOGIC;
                    signal VGA_VS_core : OUT STD_LOGIC;
                    signal bluecount : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal readdata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal x_blue : OUT STD_LOGIC_VECTOR (9 DOWNTO 0)
                 );
end component CORE;

                signal internal_Linecount_core :  STD_LOGIC_VECTOR (9 DOWNTO 0);
                signal internal_TD_RESET_core :  STD_LOGIC;
                signal internal_VGA_BLANK_core :  STD_LOGIC;
                signal internal_VGA_B_core :  STD_LOGIC_VECTOR (9 DOWNTO 0);
                signal internal_VGA_CLK_core :  STD_LOGIC;
                signal internal_VGA_G_core :  STD_LOGIC_VECTOR (9 DOWNTO 0);
                signal internal_VGA_HS_core :  STD_LOGIC;
                signal internal_VGA_R_core :  STD_LOGIC_VECTOR (9 DOWNTO 0);
                signal internal_VGA_SYNC_core :  STD_LOGIC;
                signal internal_VGA_VS_core :  STD_LOGIC;
                signal internal_bluecount :  STD_LOGIC_VECTOR (9 DOWNTO 0);
                signal internal_readdata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal internal_x_blue :  STD_LOGIC_VECTOR (9 DOWNTO 0);

begin

  --the_CORE, which is an e_instance
  the_CORE : CORE
    port map(
      Linecount_core => internal_Linecount_core,
      TD_RESET_core => internal_TD_RESET_core,
      VGA_BLANK_core => internal_VGA_BLANK_core,
      VGA_B_core => internal_VGA_B_core,
      VGA_CLK_core => internal_VGA_CLK_core,
      VGA_G_core => internal_VGA_G_core,
      VGA_HS_core => internal_VGA_HS_core,
      VGA_R_core => internal_VGA_R_core,
      VGA_SYNC_core => internal_VGA_SYNC_core,
      VGA_VS_core => internal_VGA_VS_core,
      bluecount => internal_bluecount,
      readdata => internal_readdata,
      x_blue => internal_x_blue,
      CLK50 => CLK50,
      KEY_core => KEY_core,
      TD_DATA_core => TD_DATA_core,
      TD_HS_core => TD_HS_core,
      TD_VS_core => TD_VS_core,
      address => address,
      chipselect => chipselect,
      clk27 => clk27,
      read => read,
      reset_n => reset_n,
      write => write,
      writedata => writedata
    );


  --vhdl renameroo for output signals
  Linecount_core <= internal_Linecount_core;
  --vhdl renameroo for output signals
  TD_RESET_core <= internal_TD_RESET_core;
  --vhdl renameroo for output signals
  VGA_BLANK_core <= internal_VGA_BLANK_core;
  --vhdl renameroo for output signals
  VGA_B_core <= internal_VGA_B_core;
  --vhdl renameroo for output signals
  VGA_CLK_core <= internal_VGA_CLK_core;
  --vhdl renameroo for output signals
  VGA_G_core <= internal_VGA_G_core;
  --vhdl renameroo for output signals
  VGA_HS_core <= internal_VGA_HS_core;
  --vhdl renameroo for output signals
  VGA_R_core <= internal_VGA_R_core;
  --vhdl renameroo for output signals
  VGA_SYNC_core <= internal_VGA_SYNC_core;
  --vhdl renameroo for output signals
  VGA_VS_core <= internal_VGA_VS_core;
  --vhdl renameroo for output signals
  bluecount <= internal_bluecount;
  --vhdl renameroo for output signals
  readdata <= internal_readdata;
  --vhdl renameroo for output signals
  x_blue <= internal_x_blue;

end europa;

